% Dtrsm_Example.m

close all
clear all

% Generate Data
NumParams = 4;
fun = @(p,x) p(1)*x.^3+p(2)*x.^2+p(3)*x+p(4);

xdata = [-10:1:10]';
randn('state', sum(100*clock));
variance = 0.1;
meandata = 0.0;

ydata = 3.3*xdata.^3 + 2.2*xdata.^2 + 1.1*xdata + 4.4 + ( meandata + sqrt(variance) * randn(size(xdata)) );
weights = ones(size(xdata));

xdata1=[xdata.^3 xdata.^2 xdata ones(size(xdata))];
weights1=diag(weights);

% Straight Matlab
A=xdata1'*weights1*xdata1;
b=xdata1'*weights1*ydata;
D=diag(1./diag(A));
p=zeros(NumParams,1);
residual = b-A*p;
count=0;
while norm(residual,inf)>1e-5
    count=count+1;
    p = p + D*residual;
    residual = b-A*p;
end
p_Matlab=p
NumIterations = count


% CUDA Mex
p0=zeros(NumParams,1);
p_CUDA = MexCUDA_Dtrsm2(xdata1,ydata,weights1,p0)


return
